import { IOrderbook, ImarketCodes, OBOptionsInterface } from '../interfaces';
/**
 * useWsOrderbook is a custom hook that connects to a WebSocket API
 * and retrieves real-time order book data for a given market code.
 * @param targetMarketCodes - Array of market codes to retrieve orderbook data for.
 * @param options - `throttle_time` the data update frequency(ms).
 * @throws targetMarketCodes should be React State Value, if not, unexpected errors can occur.
 * @returns Object with the WebSocket object, connection status, and real-time orderbook data.
 */
declare function useWsOrderbook(targetMarketCodes: ImarketCodes, onError?: (error: Error) => void, options?: OBOptionsInterface): {
    socket: WebSocket | null;
    isConnected: boolean;
    socketData: IOrderbook | undefined;
};
export default useWsOrderbook;
