"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isImarketCodes_1 = __importDefault(require("../../../src/functions/isImarketCodes"));
describe('isImarketCodes', () => {
    it('should return true for valid ImarketCodes objects', () => {
        const validMarketCode = {
            market: 'KRW-BTC',
            korean_name: '비트코인',
            english_name: 'Bitcoin',
        };
        expect((0, isImarketCodes_1.default)(validMarketCode)).toBe(true);
    });
    it('should return false for invalid objects', () => {
        const invalidMarketCode = {
            market: 'KRW-BTC',
            korean_name: '비트코인',
            // Missing english_name property
        };
        expect((0, isImarketCodes_1.default)(invalidMarketCode)).toBe(false);
    });
    it('should return false for non-object values', () => {
        const nonObjectValues = ['string', 42, true, null, undefined];
        nonObjectValues.forEach(value => {
            expect((0, isImarketCodes_1.default)(value)).toBe(false);
        });
    });
});
