"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const useWsTicker_1 = __importDefault(require("../../../src/hooks/useWsTicker"));
const React = __importStar(require("react"));
const react_1 = require("react");
const react_2 = require("@testing-library/react");
require("@testing-library/jest-dom/extend-expect");
const debugTest = false;
const TestTickerComponent = ({ customMarketCode, onError, }) => {
    const [marketCode, setMarketCode] = (0, react_1.useState)([
        {
            market: 'KRW-BTC',
            korean_name: '비트코인',
            english_name: 'Bitcoin',
        },
    ]);
    (0, react_1.useEffect)(() => {
        if (customMarketCode) {
            setMarketCode(() => customMarketCode);
        }
    }, [customMarketCode]);
    const { isConnected, socketData } = (0, useWsTicker_1.default)(marketCode, onError, {
        debug: debugTest,
    });
    return (React.createElement("div", null,
        isConnected ? React.createElement("p", null, "Connected") : React.createElement("p", null, "Not Connected"),
        socketData && socketData.length > 0 && (React.createElement("ul", { "data-testid": "socket-data" }, socketData.map((data, index) => (React.createElement("li", { key: index },
            data.code,
            " - ",
            data.trade_price)))))));
};
describe('useWsTicker hook', () => {
    // Test invalid targetMarketCodes
    // it('useWsTicker should throw error with invalid targetMarketCodes', () => {
    //   const onError: jest.MockedFunction<(error: Error) => void> = jest.fn();
    //   const invalidTargetMarketCodes = [
    //     {
    //       market: 'KRW-BTC',
    //       korean_name: '비트코인',
    //       english_name: 'Bitcoin',
    //     },
    //     {
    //       market: 'KRW-ETH',
    //       korean_name: '이더리움',
    //     },
    //   ];
    //   // Render the TestOrderbookComponent
    //   render(
    //     <ErrorBoundary onError={onError}>
    //       <TestTickerComponent
    //         customMarketCode={invalidTargetMarketCodes}
    //         onError={onError}
    //       />
    //     </ErrorBoundary>,
    //   );
    //   expect(onError).toHaveBeenCalled();
    //   expect(onError.mock.calls[0][0].message).toBe(
    //     'targetMarketCodes does not have the correct interface',
    //   );
    // });
    it('renders connection status and received socket data', () => __awaiter(void 0, void 0, void 0, function* () {
        // Render the TestTickerComponent
        (0, react_2.render)(React.createElement(TestTickerComponent, null));
        // Check if the connection status is displayed
        const connectionStatus = react_2.screen.getByText(/Connected|Not Connected/i);
        expect(connectionStatus).toBeInTheDocument();
        // Wait for the socket data to be displayed
        const socketDataList = yield react_2.screen.findByTestId('socket-data', {}, { timeout: 5000 });
        // Check if the socket data is displayed
        expect(socketDataList).toBeInTheDocument();
        expect(socketDataList.children.length).toBeGreaterThan(0);
    }));
});
