"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Test code
const useWsTrade_1 = __importDefault(require("../../../src/hooks/useWsTrade"));
const React = __importStar(require("react"));
const react_1 = require("react");
const react_2 = require("@testing-library/react");
require("@testing-library/jest-dom/extend-expect");
const react_3 = require("react");
const debugTest = false;
const TestTradeComponent = ({ customMarketCode, onError, }) => {
    const [marketCode, setMarketCode] = (0, react_1.useState)({
        market: 'KRW-BTC',
        korean_name: '비트코인',
        english_name: 'Bitcoin',
    });
    (0, react_3.useEffect)(() => {
        if (customMarketCode) {
            setMarketCode(() => customMarketCode);
        }
    }, [customMarketCode]);
    const { isConnected, socketData } = (0, useWsTrade_1.default)(marketCode, onError, {
        debug: debugTest,
    });
    return (React.createElement("div", null,
        isConnected ? React.createElement("p", null, "Connected") : React.createElement("p", null, "Not Connected"),
        socketData && (React.createElement("ul", { "data-testid": "socket-data" }, socketData.map((trade, index) => (React.createElement("li", { key: index, "data-testid": `trade-data-${index}` },
            "Price: ",
            trade.trade_price,
            " | Volume: ",
            trade.trade_volume)))))));
};
describe('useWsTrade hook', () => {
    // Test invalid targetMarketCodes
    // it('useWsTrade should throw error with invalid targetMarketCodes', () => {
    //   const onError: jest.MockedFunction<(error: Error) => void> = jest.fn();
    //   const invalidTargetMarketCodes = {
    //     market: 'test_market',
    //     korean_name: 'test_korean',
    //   };
    //   // Render the TestTradeComponent
    //   render(
    //     <ErrorBoundary onError={onError}>
    //       <TestTradeComponent
    //         customMarketCode={invalidTargetMarketCodes}
    //         onError={onError}
    //       />
    //     </ErrorBoundary>,
    //   );
    //   expect(onError).toHaveBeenCalled();
    //   expect(onError.mock.calls[0][0].message).toBe(
    //     'targetMarketCodes does not have the correct interface',
    //   );
    // });
    it('renders connection status and received socket data', () => __awaiter(void 0, void 0, void 0, function* () {
        // Render the TestTradeComponent
        (0, react_2.render)(React.createElement(TestTradeComponent, null));
        // Check if the connection status is displayed
        const connectionStatus = react_2.screen.getByText(/Connected|Not Connected/i);
        expect(connectionStatus).toBeInTheDocument();
        // Wait for the socket data to be displayed
        const socketDataList = yield react_2.screen.findByTestId('socket-data', {}, { timeout: 5000 });
        // Check if the socket data is displayed
        expect(socketDataList).toBeInTheDocument();
        expect(socketDataList.children.length).toBeGreaterThan(0);
    }));
    it('received socket data correctly', () => __awaiter(void 0, void 0, void 0, function* () {
        // Render the TestTradeComponent
        (0, react_2.render)(React.createElement(TestTradeComponent, null));
        // Check if the connection status is displayed
        const connectionStatus = react_2.screen.getByText(/Connected|Not Connected/i);
        expect(connectionStatus).toBeInTheDocument();
        // Wait for the socket data to be displayed
        const socketDataList = yield react_2.screen.findByTestId('socket-data', {}, { timeout: 5000 });
        // Check if the socket data is displayed
        expect(socketDataList).toBeInTheDocument();
        expect(socketDataList.children.length).toBeGreaterThan(0);
        // Test the socketData content
        yield (0, react_2.waitFor)(() => __awaiter(void 0, void 0, void 0, function* () {
            const tradeDataItems = yield react_2.screen.findAllByTestId(/trade-data-\d+/);
            // Check if there are trade data items
            expect(tradeDataItems.length).toBeGreaterThan(0);
            // Test one of the trade data items
            const firstTradeData = tradeDataItems[0];
            if (firstTradeData.textContent) {
                const priceMatch = firstTradeData.textContent.match(/Price: (\d+\.?\d+)/);
                const volumeMatch = firstTradeData.textContent.match(/Volume: (\d+\.\d+)/);
                if (priceMatch && volumeMatch) {
                    const price = parseFloat(priceMatch[1]);
                    const volume = parseFloat(volumeMatch[1]);
                    expect(price).toBeGreaterThan(0);
                    expect(volume).toBeGreaterThan(0);
                }
                else {
                    throw new Error('Failed to match price and volume in the trade data item');
                }
            }
            else {
                throw new Error('Trade data item has no text content');
            }
        }));
    }));
});
